/* GCC */

#include <fstream>
#include <bitset>
#include <vector>

using namespace std;

struct Position
{
    bitset<18> Val;    
};

ifstream fin;
ofstream fout;
bool gametype;
Position Start;
vector<int> win1, win2;
int n;

inline bool AtLeastOneWin(Position &pos);

inline bool AllWin(Position &pos)
{
    Position tmpPos;
    for(int i = 0; i < n; i++)
    {
        if(pos.Val[i])
        {
            tmpPos = pos;
            tmpPos.Val[i] = 0;
            if(!AtLeastOneWin(tmpPos))
                return false;
            if(i != 17)
                if(Start.Val[i+1])
                {
                     tmpPos.Val[i+1] = 0;
                     if(!AtLeastOneWin(tmpPos))
                         return false;
                }
        }        
    }
    return true;
}

inline bool AtLeastOneWin(Position &pos)
{
    Position tmpPos;
   
    for(int i = 0; i < n; i++)
    {
        if(pos.Val[i])
        {
            tmpPos = pos;
            tmpPos.Val[i] = 0;
            if(AllWin(tmpPos))
                return true;
            if(i != 17)
                if(Start.Val[i+1])
                {
                     tmpPos.Val[i+1] = 0;
                     if(AllWin(tmpPos))
                         return true;
                }
        }        
    }
    return false;
}

int main()
{
    win1.clear();
    win2.clear();
    int tmp;
    fin.open("game.in");
    fin>>tmp;
    gametype = tmp == 1;
    for(n = 0; fin>>tmp; n++)
    {
        Start.Val[n] = tmp;
    }
    fin.close();
    bool b;
    Position tmpPos;
    for(int i = 0; i < n; i++)
    {
        if(Start.Val[i])
        {
            tmpPos = Start;
            tmpPos.Val[i] = 0;
            b = AllWin(tmpPos);
            if(b == gametype)
                win1.push_back(i+1);
            if(i != 17)
                if(Start.Val[i+1])
                {
                     tmpPos.Val[i+1] = 0;
                     b = AllWin(tmpPos);
                     if(b == gametype)
                         win2.push_back(i+1);
                }
        }        
    }
    
    fout.open("game.out");
    for(int i = 0; i < win1.size(); i++)
    {
        fout<<win1[i]<<' '; 
    }
    fout<<endl;
    for(int i = 0; i < win2.size(); i++)
    {
        fout<<win2[i]<<' ';  
    }
    fout<<endl;
    fout.close();
    return 0;
}
